<?php
class pluginKickEmbed extends Plugin {
    public function init()
    {
        $this->dbFields = array();
    }
    public function siteHead()
    {
        echo '<style>
                .kick-embed {
                    position: relative;
                    padding-bottom: 56.25%;
                    height: 0;
                    overflow: hidden;
                    margin-bottom: 10px;
                }
                .kick-embed iframe {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    frameborder: 0;
                    allow: "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture";
                    allowfullscreen;
                }
              </style>';
    }
    public function siteBodyEnd() {
        echo <<<HTML
    <script>
    document.addEventListener("DOMContentLoaded", function() {
        function createKickEmbed(kickId) {
            var div = document.createElement('div');
            div.className = 'kick-embed';
            div.innerHTML = '<iframe src="https://player.kick.com/' + kickId + '" frameborder="0" scrolling="no" allowfullscreen="true"></iframe>';
            return div;
        }
        var paragraphs = document.querySelectorAll('p');
        paragraphs.forEach(function(p) {
            var html = p.innerHTML;
            var regex = /\\s*\\[kick=(.*?)\\]\\s*/g;
            var match, hasReplacement = false;
            while (match = regex.exec(html)) {
                var kickEmbed = createKickEmbed(match[1]);
                if (!hasReplacement) {
                    p.parentNode.replaceChild(kickEmbed, p);
                    hasReplacement = true;
                } else {
                    p.parentNode.insertBefore(kickEmbed, p.nextSibling);
                }
            }
        });
    });
    </script>
    HTML;
    }
}